﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.IO;
using System.Threading;
using System.Runtime.InteropServices;
/*******************************************************************************************************
 *                        磁気キャンセラ（アクティブ磁気シールド）プログラムV1.0
 * 
 *                                                                             2009.12.22(Neo-Tech-Lab)
 *                                                                                  H.GURITA
 * 
 ******************************************************************************************************/
namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {//unionの代わりのオフセット付構造体（double型，符号付short型）
        [StructLayout(LayoutKind.Explicit)]
        struct D_byte
        {
            [FieldOffset(0)]
            public double dbl64;
            [FieldOffset(0)]
            public byte byt0;
            [FieldOffset(1)]
            public byte byt1;
            [FieldOffset(2)]
            public byte byt2;
            [FieldOffset(3)]
            public byte byt3;
            [FieldOffset(4)]
            public byte byt4;
            [FieldOffset(5)]
            public byte byt5;
            [FieldOffset(6)]
            public byte byt6;
            [FieldOffset(7)]
            public byte byt7;
        }
        [StructLayout(LayoutKind.Explicit)]
        struct S_byte
        {
            [FieldOffset(0)]
            public short sht16;
            [FieldOffset(0)]
            public byte byt0;
            [FieldOffset(1)]
            public byte byt1;
        }
        byte[] SDATA = new byte[2];//シリアル通信で送るコマンド用
        int gx0, gy0, gx1, gy1, gx2, gy2;//グラフ表示用変数
        int count, i, j, sflag = 0;
        int ad0, ad1, ad2;
        //グラフ表示係数（縦軸）：16count/1uT * 20uT / 64dot = 5.078
        //横軸はマイコン側から62.5ms毎にデータが送られてくるので64ドット／グリッドで4秒となる
        short FS = 5;

        S_byte MGdata;
        Graphics g;

        public Form1()
        {
            InitializeComponent();
        }
        //自動モードでの処理
        //シリアルポート１：係数行列の受信やコマンドの送信で使用
        //シリアルポート２：マイコンから送られた磁気計測値を受信割り込みで表示する
        //シリアルポート１と２は物理的には同じポートを使用している（同時にオープンしない）
        private void button1_Click(object sender, EventArgs e)
        {
            if (sflag == 0)
            {
                sflag = 1;
                gx0 = 0; gx1 = 0; gx2 = 0; count = 0;
                button1.Text = "自動モードOFF";
                button2.Enabled = false;
                D_byte DBD;
                DBD.dbl64 = 0.0;
                g = pictureBox1.CreateGraphics();
                g.Clear(Color.Black);
                for (i = 0; i <= 512; i += 64)
                {
                    g.DrawLine(Pens.Green, i, 0, i, 512);
                }
                for (j = 0; j <= 512; j += 64)
                {
                    g.DrawLine(Pens.Green, 0, j, 512, j);
                }
                for (i = 0; i <= 512; i += 16)
                {
                    g.DrawLine(Pens.Green, i, 253, i, 258);
                }
                for (j = 0; j <= 512; j += 16)
                {
                    g.DrawLine(Pens.Green, 253, j, 258, j);
                }
                serialPort1.PortName = textBox2.Text;
                serialPort2.PortName = textBox2.Text;
                serialPort1.Open();
                SDATA[0] = 0x60;//自動モードOFF（手動モードON）
                SDATA[1] = 0x00;
                serialPort1.Write(SDATA, 0, 2);
                Thread.Sleep(5);//コマンド送信後少し待つ
                SDATA[0] = 0x40;//係数行列計測
                SDATA[1] = 0x00;
                serialPort1.Write(SDATA, 0, 2);
                textBox1.Text = "係数行列，逆行列　測定中・・・" + Environment.NewLine + Environment.NewLine;
                while(serialPort1.BytesToRead == 0) Application.DoEvents();
                try
                {
                    textBox1.Text += "係数行列" + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "A[0][0] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "A[0][1] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "A[0][2] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "A[1][0] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "A[1][1] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "A[1][2] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "A[2][0] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "A[2][1] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "A[2][2] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                    textBox1.Text += Environment.NewLine + "係数逆行列" + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "AI[0][0] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "AI[0][1] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "AI[0][2] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "AI[1][0] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "AI[1][1] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "AI[1][2] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "AI[2][0] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "AI[2][1] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "AI[2][2] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                    textBox1.Text += Environment.NewLine + "係数行列×逆行列" + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "I[0][0] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "I[0][1] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "I[0][2] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "I[1][0] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "I[1][1] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "I[1][2] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "I[2][0] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "I[2][1] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                    DBD.byt7 = (byte)serialPort1.ReadByte();
                    DBD.byt6 = (byte)serialPort1.ReadByte();
                    DBD.byt5 = (byte)serialPort1.ReadByte();
                    DBD.byt4 = (byte)serialPort1.ReadByte();
                    DBD.byt3 = (byte)serialPort1.ReadByte();
                    DBD.byt2 = (byte)serialPort1.ReadByte();
                    DBD.byt1 = (byte)serialPort1.ReadByte();
                    DBD.byt0 = (byte)serialPort1.ReadByte();
                    textBox1.Text += "I[2][2] = ";
                    textBox1.Text += DBD.dbl64 + Environment.NewLine;
                }
                catch (Exception)
                {
                }
                SDATA[0] = 0x50;//自動モードON
                SDATA[1] = 0x00;
                serialPort1.Write(SDATA, 0, 2);
                Thread.Sleep(5);
                SDATA[0] = 0x70;//タイマースタート
                SDATA[1] = 0x00;
                serialPort1.Write(SDATA, 0, 2);
                Thread.Sleep(5);
                serialPort1.Close();
                serialPort2.Open();
                textBox1.Text += Environment.NewLine + "自動モード　スタート" + Environment.NewLine;
                Application.DoEvents();
            }
            else
            {
                sflag = 0;
                SDATA[0] = 0x80;//タイマーストップ
                SDATA[1] = 0x00;
                serialPort2.Write(SDATA, 0, 2);
                Thread.Sleep(5);
                SDATA[0] = 0x60;//自動モードOFF
                SDATA[1] = 0x00;
                serialPort2.Write(SDATA, 0, 2);
                Thread.Sleep(5);
                serialPort2.Close();
                button1.Text = "自動モードON";
                button2.Enabled = true;
                textBox1.Text += Environment.NewLine + "自動モード　ストップ";
            }
        }
        //手動モードでの処理
        private void button2_Click(object sender, EventArgs e)
        {
            if (sflag == 0)
            {
                sflag = 1;
                gx0 = 0; gx1 = 0; gx2 = 0; count = 0;
                button2.Text = "手動モードOFF";
                button1.Enabled = false;
                trackBar1.Enabled = true;
                trackBar1.Value = 0;
                trackBar2.Enabled = true;
                trackBar2.Value = 0;
                trackBar3.Enabled = true;
                trackBar3.Value = 0;
                textBox3.Text = "0";
                textBox4.Text = "0";
                textBox5.Text = "0";
                g = pictureBox1.CreateGraphics();
                g.Clear(Color.Black);
                for (i = 0; i <= 512; i += 64)
                {
                    g.DrawLine(Pens.Green, i, 0, i, 512);
                }
                for (j = 0; j <= 512; j += 64)
                {
                    g.DrawLine(Pens.Green, 0, j, 512, j);
                }
                for (i = 0; i <= 512; i += 16)
                {
                    g.DrawLine(Pens.Green, i, 253, i, 258);
                }
                for (j = 0; j <= 512; j += 16)
                {
                    g.DrawLine(Pens.Green, 253, j, 258, j);
                }
                serialPort1.PortName = textBox2.Text;
                serialPort2.PortName = textBox2.Text;
                serialPort1.Open();
                SDATA[0] = 0x60;//手動モードON
                SDATA[1] = 0x00;
                serialPort1.Write(SDATA, 0, 2);
                Thread.Sleep(5);
                SDATA[0] = 0x07;//DA0 = 2047
                SDATA[1] = 0xFF;
                serialPort1.Write(SDATA, 0, 2);
                Thread.Sleep(5);
                SDATA[0] = 0x17;//DA1 = 2047
                SDATA[1] = 0xFF;
                serialPort1.Write(SDATA, 0, 2);
                Thread.Sleep(5);
                SDATA[0] = 0x27;//DA2 = 2047
                SDATA[1] = 0xFF;
                serialPort1.Write(SDATA, 0, 2);
                Thread.Sleep(5);
                SDATA[0] = 0x70;//タイマースタート
                SDATA[1] = 0x00;
                serialPort1.Write(SDATA, 0, 2);
                Thread.Sleep(5);
                serialPort1.Close();
                serialPort2.Open();
                textBox1.Text = "手動モード　スタート" + Environment.NewLine;
                Application.DoEvents();
            }
            else
            {
                sflag = 0;
                SDATA[0] = 0x80;//タイマーストップ
                SDATA[1] = 0x00;
                serialPort2.Write(SDATA, 0, 2);
                Thread.Sleep(5);
                serialPort2.Close();
                trackBar1.Enabled = false;
                trackBar2.Enabled = false;
                trackBar3.Enabled = false;
                button3.Enabled = false;
                button4.Enabled = false;
                button5.Enabled = false;
                button2.Text = "手動モードON";
                button1.Enabled = true;
                textBox1.Text += Environment.NewLine + "手動モード　ストップ";
            }
        }
        //グラフ表示のための受信割り込み
        private void serialPort2_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            try
            {
                MGdata.byt1 = (byte)serialPort2.ReadByte();
                MGdata.byt0 = (byte)serialPort2.ReadByte();
                ad0 = 256 - MGdata.sht16 / FS;
                MGdata.byt1 = (byte)serialPort2.ReadByte();
                MGdata.byt0 = (byte)serialPort2.ReadByte();
                ad1 = 256 - MGdata.sht16 / FS;
                MGdata.byt1 = (byte)serialPort2.ReadByte();
                MGdata.byt0 = (byte)serialPort2.ReadByte();
                ad2 = 256 - MGdata.sht16 / FS;
                g.DrawLine(Pens.Red, gx0, gy0, gx0 + 1, ad0);
                gx0++; gy0 = ad0;
                g.DrawLine(Pens.Blue, gx1, gy1, gx1 + 1, ad1);
                gx1++; gy1 = ad1;
                g.DrawLine(Pens.Yellow, gx2, gy2, gx2 + 1, ad2);
                gx2++; gy2 = ad2;
                count++;
                if (count > 512)
                {
                    gx0 = 0; gx1 = 0; gx2 = 0; count = 0;
                    g.Clear(Color.Black);
                    for (i = 0; i <= 512; i += 64)
                    {
                        g.DrawLine(Pens.Green, i, 0, i, 512);
                    }
                    for (j = 0; j <= 512; j += 64)
                    {
                        g.DrawLine(Pens.Green, 0, j, 512, j);
                    }
                    for (i = 0; i <= 512; i += 16)
                    {
                        g.DrawLine(Pens.Green, i, 253, i, 258);
                    }
                    for (j = 0; j <= 512; j += 16)
                    {
                        g.DrawLine(Pens.Green, 253, j, 258, j);
                    }
                }
            }
            catch (Exception)
            {
            }
        }
        //手動モード時のトラックバーと送信ボタンの処理
        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            textBox3.Text = Convert.ToString(trackBar1.Value);
            button3.Enabled = true;
            if ((trackBar1.Value > 80) || (trackBar1.Value < -80))
            {
                textBox3.BackColor = Color.Orange;
            }
            else
            {
                textBox3.BackColor = Color.Silver;
            }
            
        }

        private void trackBar2_Scroll(object sender, EventArgs e)
        {
            textBox4.Text = Convert.ToString(trackBar2.Value);
            button4.Enabled = true;
            if ((trackBar2.Value > 80) || (trackBar2.Value < -80))
            {
                textBox4.BackColor = Color.Orange;
            }
            else
            {
                textBox4.BackColor = Color.Silver;
            }
        }

        private void trackBar3_Scroll(object sender, EventArgs e)
        {
            textBox5.Text = Convert.ToString(trackBar3.Value);
            button5.Enabled = true;
            if ((trackBar3.Value > 80) || (trackBar3.Value < -80))
            {
                textBox5.BackColor = Color.Orange;
            }
            else
            {
                textBox5.BackColor = Color.Silver;
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            UInt16 sd = (UInt16)((Convert.ToInt16(textBox3.Text) + 100) * 0x0FFF / 200);
            SDATA[0] = (byte)(0x0000 | (sd >> 8));
            SDATA[1] = (byte)(sd & 0x00FF);
            serialPort2.Write(SDATA, 0, 2);
            button3.Enabled = false;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            UInt16 sd = (UInt16)((Convert.ToInt16(textBox4.Text) + 100) * 0x0FFF / 200);
            SDATA[0] = (byte)(0x0010 | (sd >> 8));
            SDATA[1] = (byte)(sd & 0x00FF);
            serialPort2.Write(SDATA, 0, 2);
            button4.Enabled = false;
        }

        private void button5_Click(object sender, EventArgs e)
        {
            UInt16 sd = (UInt16)((Convert.ToInt16(textBox5.Text) + 100) * 0x0FFF / 200);
            SDATA[0] = (byte)(0x0020 | (sd >> 8));
            SDATA[1] = (byte)(sd & 0x00FF);
            serialPort2.Write(SDATA, 0, 2);
            button5.Enabled = false;
        }

    }
}
