/******************************************************************************/
/* CLZiANeBuCV[hjvOV1.0                     */
/*                                                                            */
/*                                              2009.12.22  Neo-Tech-Lab      */
/*                                                         H.GURITA           */
/******************************************************************************/

#include <ADuC7026.H>               // ADuC7026 definitions

/************************************************
***** Pin Assign ********************************
P4.4 - P4.7  = DA
P1.0 = Sin(RxD:input)
P1.1 = Sout(TxD)
P1.2 = Mg DRDY(input)
P1.3 = Mg RESET(output)
P1.4 = Mg CLK(output)
P1.5 = Mg MISO(input)
P1.6 = Mg MOSI(output)
P1.7 = Mg CS(output)
*/

//Wsƌvf[^unionŒ`
union d_byte
{  double d64;
   unsigned char d8[8];
} DBLdata;

union s_byte
{  short s16;
   unsigned char d8[2];
} SHTdata;
//O[oϐ
double A[3][3] = {{0.0, 0.0, 0.0},{0.0, 0.0, 0.0},{0.0, 0.0, 0.0}};//Ws
double AI[3][3] = {{0.0, 0.0, 0.0},{0.0, 0.0, 0.0},{0.0, 0.0, 0.0}};//Wts
double AM = 1.0;//s񎮂̒l
double MgXoff = 0.0, MgYoff = 0.0, MgZoff = 0.0;//ItZbgEnCigpj
double COIL0 = 0.0, COIL1 = 0.0, COIL2 = 0.0;//RCXCYCZɗd
int Aflag = 0;//[hLEtO
int Tflag = 0;//^C}[荞ݗLEtO
char MX = 0x51, MY = 0x52, MZ = 0x53;
double MG = 1.0;//feedback gain
short MDX, MDY, MDZ;//CZT[XCYCŽvl

//|[g̏
void INIT_PORT(void)
{   PLLKEY1 = 0xAA;// internal 41.78MHz
    PLLCON = 0x21;
    PLLKEY2 = 0x55;
    POWKEY1 = 0x01;
    POWCON = 0x00;
    POWKEY2 = 0xF4;
  
    GP0CON = 0x00000000; // all GPIO
    GP1CON = 0x02220011; // 0,1 = serial 4,5,6 = SPI
    GP2CON = 0x00000000; // all GPIO
    GP3CON = 0x22222222; // all AD
    GP4CON = 0x22222222; // all AD(DA)
    GP0PAR = 0x00000000; // PULLUP
    GP1PAR = 0x11111110; // PULLUP = P0 
    GP3PAR = 0x11111111; // No PULLUP
    GP0DAT = 0x00000000; // INPUT
    GP1DAT = 0x8A800000; // OUT=P1,3(RESET:Lo),7(CS:Hi)
    GP2DAT = 0x00000000; // INPUT
    GP3DAT = 0x00000000; // INPUT
    GP4DAT = 0x00000000; // INPUT

    COMCON0 = 0x080; // Setting DLAB
    COMDIV0 = 0x00B; // 115200BPS
    COMDIV1 = 0x000;
    COMCON0 = 0x003; // Clearing DLAB

    SPIDIV = 0x14; // 995kbps
    SPICON = 0x00C3; // SPI master & SPI & Ov,Uv enable

    DAC0CON = 0x13; // Configure DAC0 Range 0..VDD
    DAC1CON = 0x13; // Configure DAC0 Range 0..VDD
    DAC2CON = 0x13; // Configure DAC0 Range 0..VDD
    DAC3CON = 0x13; // Configure DAC0 Range 0..VDD

    IRQEN = 0x00000004; // Enable Timer 0 Interrupt
    FIQEN = 0x00004000; // Enable UART FInterrupt
    COMIEN0 = 0x001; // RXF interrupt
    T0LD  = 10200; // Timer 0 Load Value(10200 / 41.78Mhz * 256 = 0.0625)
    T0CON = 0xC8; // Timer 0 Enabled, Periodic, Prescaler = 256
}

//VA|[gM
void PutC(int ch)
{   while((COMSTA0 & 0x40) == 0) {}
    COMTX = ch;
}

int GetC(void)
{   while((COMSTA0 & 0x01) == 0) {}
    return (COMRX);
}

//ԑ҂֐
void Delay(int cnt)
{    while (cnt > 0)
    {    cnt--;
    }
}

void Delay2(int cnt)
{    while (cnt > 0)
    {    Delay(5000);
    	cnt--;
    }
}

//CZT[vlM
//SPI MISO = P1.5 MOSI = P1.6 CLK = P1.4
short MGread(char c)
{   GP1CLR = 0x00800000; //P1.7 Lo(CS)
    Delay(100);
    GP1SET = 0x00080000; //P1.3 Hi(reset)
    Delay(10);
    GP1CLR = 0x00080000; //P1.3 Lo
    Delay(100);
    SPITX = c;
    while((SPISTA & 0x00000008) == 0) {} //wait SPI RX
    SHTdata.d8[0] = SPIRX; //dummy read
    while((GP1DAT & 0x00000004) == 0) {} //wait DRDY(P1.2) = 1
    SPITX = 0xAA; //dummy send
    while((SPISTA & 0x00000008) == 0) {}
    SHTdata.d8[1] = SPIRX; //read Hi byte
    SPITX = 0xAA; //dummy send
    while((SPISTA & 0x00000008) == 0) {}
    SHTdata.d8[0] = SPIRX; //read Lo byte
    Delay(100);
    GP1SET = 0x00800000; //P1.7 Hi(CS)
    return (SHTdata.s16);
}

//o͓dDAC̒lvZ
//RL = 1.1ohm
//0.909A/V
//-4.1 <= V <= +4.1
//-3.7 <= A <= +3.7
//1A = 4095 / 9V * 1.1 = 500.5
// -3.7 <= C0,C1,C2 <= 3.7
void COUT(void)
{   if(COIL0 < -3.7) COIL0 = -3.7; if(COIL0 > 3.7) COIL0 = 3.7;
    if(COIL1 < -3.7) COIL1 = -3.7; if(COIL1 > 3.7) COIL1 = 3.7;
    if(COIL2 < -3.7) COIL2 = -3.7; if(COIL2 > 3.7) COIL2 = 3.7;
    DAC0DAT = (int)(2047.5 + 500.5 * COIL0) << 16;
    DAC1DAT = (int)(2047.5 + 500.5 * COIL1) << 16;
    DAC2DAT = (int)(2047.5 + 500.5 * COIL2) << 16;
}

//WsCtsCZʂ̑M
//uniongp
void MAT_SEND(void)
{   DBLdata.d64 = A[0][0];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
    DBLdata.d64 = A[0][1];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
    DBLdata.d64 = A[0][2];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
    DBLdata.d64 = A[1][0];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
    DBLdata.d64 = A[1][1];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
    DBLdata.d64 = A[1][2];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
    DBLdata.d64 = A[2][0];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
    DBLdata.d64 = A[2][1];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
    DBLdata.d64 = A[2][2];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
    
    DBLdata.d64 = AI[0][0];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
    DBLdata.d64 = AI[0][1];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
    DBLdata.d64 = AI[0][2];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
    DBLdata.d64 = AI[1][0];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
    DBLdata.d64 = AI[1][1];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
    DBLdata.d64 = AI[1][2];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
    DBLdata.d64 = AI[2][0];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
    DBLdata.d64 = AI[2][1];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
    DBLdata.d64 = AI[2][2];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
    
    DBLdata.d64 = A[0][0] * AI[0][0] + A[0][1] * AI[1][0] + A[0][2] * AI[2][0];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
    DBLdata.d64 = A[0][0] * AI[0][1] + A[0][1] * AI[1][1] + A[0][2] * AI[2][1];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
    DBLdata.d64 = A[0][0] * AI[0][2] + A[0][1] * AI[1][2] + A[0][2] * AI[2][2];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
    DBLdata.d64 = A[1][0] * AI[0][0] + A[1][1] * AI[1][0] + A[1][2] * AI[2][0];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
    DBLdata.d64 = A[1][0] * AI[0][1] + A[1][1] * AI[1][1] + A[1][2] * AI[2][1];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
    DBLdata.d64 = A[1][0] * AI[0][2] + A[1][1] * AI[1][2] + A[1][2] * AI[2][2];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
    DBLdata.d64 = A[2][0] * AI[0][0] + A[2][1] * AI[1][0] + A[2][2] * AI[2][0];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
    DBLdata.d64 = A[2][0] * AI[0][1] + A[2][1] * AI[1][1] + A[2][2] * AI[2][1];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
    DBLdata.d64 = A[2][0] * AI[0][2] + A[2][1] * AI[1][2] + A[2][2] * AI[2][2];
    PutC(DBLdata.d8[7]);PutC(DBLdata.d8[6]);PutC(DBLdata.d8[5]);PutC(DBLdata.d8[4]);
    PutC(DBLdata.d8[3]);PutC(DBLdata.d8[2]);PutC(DBLdata.d8[1]);PutC(DBLdata.d8[0]);
}

//tsvZ
void MAT_INV(void)
{   AM = A[0][0] * A[1][1] * A[2][2] + A[0][1] * A[1][2] * A[2][0] + A[0][2] * A[2][1] * A[1][0]
         - A[0][2] * A[1][1] * A[2][0] - A[0][1] * A[1][0] * A[2][2] - A[0][0] * A[2][1] * A[1][2];
    AI[0][0] = (A[1][1] * A[2][2] - A[1][2] * A[2][1]) / AM;
    AI[1][0] = -1.0 * (A[1][0] * A[2][2] - A[1][2] * A[2][0]) / AM;
    AI[2][0] = (A[1][0] * A[2][1] - A[1][1] * A[2][0]) / AM;
    AI[0][1] = -1.0 * (A[0][1] * A[2][2] - A[0][2] * A[2][1]) / AM;
    AI[1][1] = (A[0][0] * A[2][2] - A[0][2] * A[2][0]) / AM;
    AI[2][1] = -1.0 * (A[0][0] * A[2][1] - A[0][1] * A[2][0]) / AM;
    AI[0][2] = (A[0][1] * A[1][2] - A[0][2] * A[1][1]) / AM;
    AI[1][2] = -1.0 * (A[0][0] * A[1][2] - A[0][2] * A[1][0]) / AM;
    AI[2][2] = (A[0][0] * A[1][1] - A[0][1] * A[1][0]) / AM;
}

//WsȂ
void A_MAT(void)
{   int i;
    double xp, xn, yp, yn, zp, zn;
    COIL0 = 0.0; COIL1 = 0.0; COIL2 = 0.0;
    COUT();
    //OFFSET NOT USE
    for(i = 0; i < 20; i++)
    {   MgXoff += (double)MGread(MX);
        MgYoff += (double)MGread(MY);
        MgZoff += (double)MGread(MZ);
    }
    MgXoff /= 20.0;
    MgYoff /= 20.0;
    MgZoff /= 20.0;
    xp = xn = yp = yn = zp = zn = 0.0;
    COIL0 = 1.0; COIL1 = 0.0; COIL2 = 0.0;
    COUT();
    for(i = 0; i < 10; i++)
    {   xp += (double)MGread(MX);
        yp += (double)MGread(MY);
        zp += (double)MGread(MZ);
    }
    COIL0 = -1.0; COIL1 = 0.0; COIL2 = 0.0;
    COUT();
    for(i = 0; i < 10; i++)
    {   xn += (double)MGread(MX);
        yn += (double)MGread(MY);
        zn += (double)MGread(MZ);
    }
    A[0][0] = (xp - xn) / 20.0;
    A[0][1] = (yp - yn) / 20.0;
    A[0][2] = (zp - zn) / 20.0;
    xp = xn = yp = yn = zp = zn = 0.0;
    COIL0 = 0.0; COIL1 = 1.0; COIL2 = 0.0;
    COUT();
    for(i = 0; i < 10; i++)
    {   xp += (double)MGread(MX);
        yp += (double)MGread(MY);
        zp += (double)MGread(MZ);
    }
    COIL0 = 0.0; COIL1 = -1.0; COIL2 = 0.0;
    COUT();
    for(i = 0; i < 10; i++)
    {   xn += (double)MGread(MX);
        yn += (double)MGread(MY);
        zn += (double)MGread(MZ);
    }
    A[1][0] = (xp - xn) / 20.0;
    A[1][1] = (yp - yn) / 20.0;
    A[1][2] = (zp - zn) / 20.0;
    xp = xn = yp = yn = zp = zn = 0.0;
    COIL0 = 0.0; COIL1 = 0.0; COIL2 = 1.0;
    COUT();
    for(i = 0; i < 10; i++)
    {   xp += (double)MGread(MX);
        yp += (double)MGread(MY);
        zp += (double)MGread(MZ);
    }
    COIL0 = 0.0; COIL1 = 0.0; COIL2 = -1.0;
    COUT();
    for(i = 0; i < 10; i++)
    {   xn += (double)MGread(MX);
        yn += (double)MGread(MY);
        zn += (double)MGread(MZ);
    }
    A[2][0] = (xp - xn) / 20.0;
    A[2][1] = (yp - yn) / 20.0;
    A[2][2] = (zp - zn) / 20.0;
    COIL0 = 0.0; COIL1 = 0.0; COIL2 = 0.0;
    COUT();
}

//^C}[荞
// SPI MISO = P1.5 MOSI = P1.6 CLK = P1.4
__irq void IRQ_Handler (void)
{   int d;
    if((IRQSIG & 0x00000004) != 0)// Timer 0 Interrupt(bit3)
    {
        T0CLRI = 1; // Clear Timer 0 Interrupt
        if(Tflag == 0) return;
        GP1CLR = 0x00800000; //P1.7 Lo(CS)
        Delay(10);
        GP1SET = 0x00080000; //P1.3 Hi(reset)
        Delay(10);
        GP1CLR = 0x00080000; //P1.3 Lo
        Delay(10);
        SPITX = MX;
        while((SPISTA & 0x00000008) == 0) {} //wait SPI RX
        d = SPIRX; //dummy read
        while((GP1DAT & 0x00000004) == 0) {} //wait DRDY(P1.2) = 1
        SPITX = 0xAA; //dummy send
        while((SPISTA & 0x00000008) == 0) {}
        d = SPIRX; //read Hi byte
        SPITX = 0xAA; //dummy send
        while((SPISTA & 0x00000008) == 0) {}
        d = (d << 8) | SPIRX; //read Lo byte
        Delay(10);
        GP1SET = 0x00800000; //P1.7 Hi(CS)
        MDX = d;
        GP1CLR = 0x00800000; //P1.7 Lo(CS)
        Delay(10);
        GP1SET = 0x00080000; //P1.3 Hi(reset)
        Delay(10);
        GP1CLR = 0x00080000; //P1.3 Lo
        Delay(10);
        SPITX = MY;
        while((SPISTA & 0x00000008) == 0) {} //wait SPI RX
        d = SPIRX; //dummy read
        COIL0 -= AI[0][0] * (double)MDX * MG;
        COIL1 -= AI[1][0] * (double)MDX * MG;
        COIL2 -= AI[2][0] * (double)MDX * MG;
        PutC(MDX >> 8); // MX
        PutC(MDX);
        while((GP1DAT & 0x00000004) == 0) {} //wait DRDY(P1.2) = 1
        SPITX = 0xAA; //dummy send
        while((SPISTA & 0x00000008) == 0) {}
        d = SPIRX; //read Hi byte
        SPITX = 0xAA; //dummy send
        while((SPISTA & 0x00000008) == 0) {}
        d = (d << 8) | SPIRX; //read Lo byte
        Delay(10);
        GP1SET = 0x00800000; //P1.7 Hi(CS)
        MDY = d;
        GP1CLR = 0x00800000; //P1.7 Lo(CS)
        Delay(10);
        GP1SET = 0x00080000; //P1.3 Hi(reset)
        Delay(10);
        GP1CLR = 0x00080000; //P1.3 Lo
        Delay(10);
        SPITX = MZ;
        while((SPISTA & 0x00000008) == 0) {} //wait SPI RX
        d = SPIRX; //dummy read
        COIL0 -= AI[0][1] * (double)MDY * MG;
        COIL1 -= AI[1][1] * (double)MDY * MG;
        COIL2 -= AI[2][1] * (double)MDY * MG;
        PutC(MDY >> 8); // MY
        PutC(MDY);
        while((GP1DAT & 0x00000004) == 0) {} //wait DRDY(P1.2) = 1
        SPITX = 0xAA; //dummy send
        while((SPISTA & 0x00000008) == 0) {}
        d = SPIRX; //read Hi byte
        SPITX = 0xAA; //dummy send
        while((SPISTA & 0x00000008) == 0) {}
        d = (d << 8) | SPIRX; //read Lo byte
        Delay(10);
        GP1SET = 0x00800000; //P1.7 Hi(CS)
        MDZ = d;
        COIL0 -= AI[0][2] * (double)MDZ * MG;
        COIL1 -= AI[1][2] * (double)MDZ * MG;
        COIL2 -= AI[2][2] * (double)MDZ * MG;
        if(Aflag == 1) COUT();
        PutC(MDZ >> 8); // MZ
        PutC(MDZ);
    }
}

//VA|[gM荞
// command xxxx yyyy yyyy yyyy     xxxx:channel etc  yyyyyyyyyyyy:DAC
// xxxx 0000=cha0  0001=cha1  0010=cha2  0011 - 1111=etc
__irq void FIQ_Handler (void)
{   int com;
    if((FIQSIG & 0x00004000) != 0)// UART RX FInterrupt(bit14)
    {   com = GetC() << 8;
        com |= GetC();
        switch(com & 0xF000)//command ?
        {   case 0x0000://DAC0 manual
                DAC0DAT = com << 16;//DAC xxxx XXXX XXXX XXXX
                break;
            case 0x1000://DAC1 manual
                DAC1DAT = com << 16;
                break;
            case 0x2000://DAC2 manual
                DAC2DAT = com << 16;//DAC xxxx XXXX XXXX XXXX
                break;
            case 0x3000://DAC3 manual(NOT USE)
                DAC3DAT = com << 16;//DAC xxxx XXXX XXXX XXXX
                break;
            case 0x4000://A matrix
                Tflag = 0; // Timer 0 Stop
                A_MAT();
                MAT_INV();
                MAT_SEND();
                break;
            case 0x5000://DAC Auto
                Aflag = 1; // Autoflag = 1
                break;
            case 0x6000://DAC Manual
                Aflag = 0; // Autoflag = 0
                break;
            case 0x7000://Timer 0 enable
                Delay2(1000);//wait for PC
                Tflag = 1;
                break;
            case 0x8000://Timer 0 disable
                Tflag = 0;
                break;
            default: break;
        }
    }
}

//gȂ荞݃nhLqȂƃRpCG[ɂȂ
__irq void DAbt_Handler (void)
{
}

__irq void PAbt_Handler (void)
{
}

__irq void SWI_Handler (void)
{
}

__irq void Undef_Handler (void)
{
}

//Main Program
int main(void)
{   INIT_PORT();
    DAC0DAT = 2047 << 16;
    DAC1DAT = 2047 << 16;
    DAC2DAT = 2047 << 16;
    DAC3DAT = 2047 << 16;
    while(1)
    {   }
}
